package apps;

import java.io.IOException;

import com.ibm.rhapsody.apps.apps.UI3App;
import com.ibm.rhapsody.apps.utils.Reporter;
import com.telelogic.rhapsody.core.IRPApplication;
import com.telelogic.rhapsody.core.IRPModelElement;


public class MainApp extends UI3App {
	
	private MBDGManager manager;
	
	protected void initialize() {
		super.initialize();
		
		if (manager == null) {
			manager = new MBDGManager(rhapsody);
		}			
		
		sShell.setText("Generate Document ... ");
		label1.setText("Document Path: ");
		text1.setText(manager.getConfiguration().getDocumentPath());
		buttonOK.setText("Generate");
		buttonCancel.setText("Close");	
	}
	
	/*
	* This method is called on invoking an app inside Rhapsody.
	* rhapsody - Instance of an active Rhapsody application 
	* selected - Selected element in Rhapsody
	* value    - Input in dialog
	*/
	public void execute(IRPApplication rhapsody, IRPModelElement selected, String value) {
		try {
			generateDocument(selected, value);
		} catch (Exception e) {
			Reporter.report(e);
		}
	}

	public void generateDocument(IRPModelElement selected, String path) throws IOException {
		// Rename controls to create a dialog according to your needs
		if (manager == null) {
			manager = new MBDGManager(rhapsody);
		}		
		manager.generateDocument(selected, path);
	}
	
	public void preview(IRPModelElement selected, Boolean withDescendants) throws IOException {
		// Rename controls to create a dialog according to your needs
		if (manager == null) {
			manager = new MBDGManager(rhapsody);
		}		
		manager.preview(selected, withDescendants);
	}	
	
    /*
     *  Debug app by launching it as "Java Application" is Eclipse.
	 *  Note: Select an element in Rhapsody in order to simulate launching app on a selected element in the browser.
     */		
	public static void main(String[] args) {
		MainApp app = new MainApp();
		app.invokeFromMain();
	}
}
