/*
 * Copyright (c) 2000 World Wide Web Consortium,
 * (Massachusetts Institute of Technology, Institut National de
 * Recherche en Informatique et en Automatique, Keio University). All
 * Rights Reserved. This program is distributed under the W3C's Software
 * Intellectual Property License. This program is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.
 * See W3C License http://www.w3.org/Consortium/Legal/ for more details.
 *
 * $Id: DirectAdjacentSelectorImpl.java,v 1.2 2000/07/27 21:32:26 plehegar Exp $
 */
package com.aspose.pdf.html.flute.parser.selectors;

import com.aspose.pdf.html.sac.SiblingSelector;
import com.aspose.pdf.html.sac.Selector;
import com.aspose.pdf.html.sac.SimpleSelector;

/**
 * @version $Revision: 1.2 $
 * @author  Philippe Le Hegaret
 */
public class DirectAdjacentSelectorImpl implements SiblingSelector {

    Selector       child;
    SimpleSelector directAdjacent;

    /**
     * An integer indicating the type of <code>Selector</code>
     */
    public short getSelectorType() {
	return Selector.SAC_DIRECT_ADJACENT_SELECTOR;
    }

    /**
     * Creates a new DescendantSelectorImpl
     */
    public DirectAdjacentSelectorImpl(Selector child,
				      SimpleSelector directAdjacent) {
        this.child = child;
	this.directAdjacent = directAdjacent;
    }

    public short getNodeType() {
	return 1;
    }

    /**
     * Returns the parent selector.
     */
    public Selector getSelector() {
	return child;
    }

    /*
     * Returns the simple selector.
     */
    public SimpleSelector getSiblingSelector() {
	return directAdjacent;
    }
}
