##  #!/usr/bin/perl -w
# Rip AUTOSAR constraints from a text file (text file should be saved from pdf document, such as SWC Template, and filtered from irrelevant sections)
#
# In Adobe Reader -> Select a snippet or an entire file -> Copy
# In MSWord -> New doc -> Paste
# Remove irrelevant text, such as intro and appendix, page headers/footers, etc.
# Run script to rip constraints

#use strict;
use warnings;
use IO::Handle;


if ($#ARGV != 0)
{
	print  "\nUsage: perl $0 input_file";
	# l:\StmOO\CommonEtc\Perl\bin\perl.exe  script.pl  input_file  > output_file
	exit;	
}

my $constr_prefix = "TPS_SWCT"; # For 'SWC Template' constraints

undef $/;
my $file_name = shift @ARGV;
my @col;
my $separator = "\t";

open(my $file_handle, '<', $file_name) or die "Could not open file. $!";

while (<$file_handle>) {
	
	while (/^(\[($constr_prefix|constr)_[0-9]+?\])(.*?)(^d$|^d\s|\sd$|\sd\s)(.*?)(^c$|^c\s|\sc$|[.]\c$|\sc\s|\[.]c\s|[.]c\(|^c\(|\sc[(])/smgx) {
		my $constr_id = $1;
		my $constr_name = $3;
		my $constr_descr = $5;
		for ($constr_name) {
			s/\s{2,}/ /gm;
			s/\s*? AUTOSAR CONFIDENTIAL \s*?//g;
			s/A Renamed Meta-Model Elements.*//g;
			s/[0-9]+ of [0-9]+ Document ID.*//g;
			s/\n/ /g;
		}
		if ($constr_name =~ /.*?(\[($constr_prefix|constr)_[0-9]+?\]).*?/) {
				print STDERR "Check if this constraint is \"swallowed\" by another constraint: $1\n";
		}
		for ($constr_descr) {
			s/\s{2,}/ /gm;
			s/\s*? AUTOSAR CONFIDENTIAL \s*?//g;
			s/A Renamed Meta-Model Elements.*//g;
			s/[0-9]+ of [0-9]+ Document ID.*//g;
			s/\n/ /g;
		}
		push @col, $separator . $separator . $separator . $separator .$separator . $separator . $constr_id . $separator . $constr_name . $separator . $constr_descr . $separator;
	}
}
close $file_handle;
#@col = sort @col;
print "Category" . $separator . "Priority" . $separator . "Status" . $separator . "Justification" . $separator . "Other comments" . $separator . "TBD". $separator . "Constraint ID" . $separator . "Constraint Name" . $separator . "Constraint Description" . $separator . "More Details" . "\n\n";
my $count = 1;
foreach my $l ( @col ) {
	print $l . "\n";
}



